﻿using BCS.SAF;
using BCS.Sym3;

namespace $safeprojectname$
{
    public class AddInRibbon : BCS.Sym3.IAddInRibbon
    {
        IAddIn addin;

        public AddInRibbon(IAddIn addin)
        {
            this.addin = addin;
        }

        BCS.Sym3.ISym3BaseEditor Editor
        {
            get { return addin.Editor; }
        }

        public void Init()
        {
            //-- add a button in the ribbon to access macro editor
            AddButtonInRibbon();
        }

        public BCS.SAF.ExecuteActionResult ExecuteAction(string action, object param, System.Collections.Generic.List<BCS.IBaseObject> items)
        {
            if (action == "Demo.DisplayHelloWorld")
                return ActionDisplayHelloWorld();

            return ExecuteActionResult.NotHandled;
        }

        private void AddButtonInRibbon()
        {
            string toolText = "Hello World";              //-- This is the display text for the button in the Ribbon
            string toolKey = "Demo.DisplayHelloWorld";    //-- This is key. Will be used in function 'ExecuteAction'

            //-- Step1: create a button for the Ribbon
            Editor.Application.AddRibbonTool(
                toolKey,
                toolText,
                "button",
                $safeprojectname$.Properties.Resources.Demo32,
                $safeprojectname$.Properties.Resources.Demo16, 
                "");

            //-- Step2: add an instance of this button
            Editor.Application.AddRibbonToolInstance(
                "Demo",               //-- tab key
                "Hello",              //-- group key
                toolKey,              //-- tool key
                BCS.ToolSize.Large,   //-- Button type: can be small or large
                true);                //-- specify if this button is enabled
        }

        private BCS.SAF.ExecuteActionResult ActionDisplayHelloWorld()
        {
            if (Editor.Project == null)
            {
                System.Windows.MessageBox.Show("Hello world! You don't have a project", "Demo", System.Windows.MessageBoxButton.OK, System.Windows.MessageBoxImage.Error);
            }
            else
            {
                System.Windows.MessageBox.Show(
                    $"Hello world! Your project name is {Editor.Project.Name} and you have {Editor.Project.Equipment.Count} equipment", 
                    "Demo",
                    System.Windows.MessageBoxButton.OK,
                    System.Windows.MessageBoxImage.Exclamation);
            }
            return BCS.SAF.ExecuteActionResult.Success;
        }

    }
}
