﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using BCS;
using BCS.SAF;

namespace $safeprojectname$.Panels
{
    public partial class DemoToolsPanel : UserControl, IDockablePanel
    {
        private IApplication Application { get; set; }
        private IRibbonTool m_ribbonTool;
        private BCS.Sym3.ISym3BaseEditor editor;

        internal AddInRibbon AddInRibbon { get; set; }

        public DemoToolsPanel(BCS.Sym3.ISym3BaseEditor editor, AddInRibbon addInRibbon)
        {
            this.AddInRibbon = addInRibbon;
            this.editor = editor;

            //-- This will create a button in the ribbon to open/close this panel
            m_ribbonTool = BCS.SAF.Factory.CreateRibbonTool(
                this.Key,                                 // Tool key
                "Demo",                                   // Display Name
                this.Title,                               // Tooltip text
                ToolType.StateButton,                     // tool type (button etc...)
                ToolSize.Large,                           // tool size (large, small)
                "",                                       // tool shortcut key (F5, F6 etc...)
                "Demo",                                   // Tab key
                "Demo",                                   // Group Key
                Properties.Resources.Demo32,              // image 32
                Properties.Resources.Demo16               // image 16
                );

            InitializeComponent();

            //-- In this demo we are embedding a WPF control inside the panel (WinForm technology)
            MainControl ucInit = new MainControl();
            ucInit.SetEditor(editor);
            elementHost1.Child = ucInit;
        }

        #region IDockablePanel Members

        public object UIControl { get { return this; } }

        public string Key
        {
            get { return "Sym3DemoPanel"; }
        }

        public PanelPosition DefaultLocation
        {
            get { return PanelPosition.Float; }
        }

        public bool DefaultVisibility
        {
            get { return false; }
        }

        public string Title
        {
            get { return "Demo for Sym3"; }
        }

        public IRibbonTool RibbonTool { get { return m_ribbonTool; } }

        public void OnDocumentOpened(IDocument document)
        {
        }

        public void OnDocumentClosed()
        {
        }

        public bool NeedLicense
        {
            get { return false; }
        }

        public Size DefaultFloatingSize
        {
            get { return new Size(200, 100); }
        }

        public void Activated()
        {

        }

        public void Deactivated()
        {

        }

        public void Shown() { }

        public void Hidden() { }

        #endregion
    }
}
